"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var platform_browser_1 = require('@angular/platform-browser');
var forms_1 = require('@angular/forms');
var wijmo_angular2_grid_1 = require('wijmo/wijmo.angular2.grid');
var MyGrid = (function (_super) {
    __extends(MyGrid, _super);
    function MyGrid() {
        _super.apply(this, arguments);
        this.myPropertyChange = new core_1.EventEmitter(false);
    }
    Object.defineProperty(MyGrid.prototype, "myProperty", {
        get: function () {
            return this._myProperty;
        },
        set: function (value) {
            if (this._myProperty !== value) {
                this._myProperty = value;
                this.myPropertyChange.emit(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    MyGrid = __decorate([
        core_1.Component({
            selector: 'my-grid',
            template: wijmo_angular2_grid_1.wjFlexGridMeta.template,
            inputs: wijmo_angular2_grid_1.wjFlexGridMeta.inputs.concat(['myProperty']),
            outputs: wijmo_angular2_grid_1.wjFlexGridMeta.outputs.concat(['myPropertyChange']),
            providers: [
                { provide: 'WjComponent', useExisting: core_1.forwardRef(function () { return MyGrid; }) }
            ].concat(wijmo_angular2_grid_1.wjFlexGridMeta.providers)
        }), 
        __metadata('design:paramtypes', [])
    ], MyGrid);
    return MyGrid;
}(wijmo_angular2_grid_1.WjFlexGrid));
exports.MyGrid = MyGrid;
var MyColumn = (function (_super) {
    __extends(MyColumn, _super);
    function MyColumn() {
        _super.apply(this, arguments);
    }
    MyColumn = __decorate([
        core_1.Component({
            selector: 'my-column',
            template: wijmo_angular2_grid_1.wjFlexGridColumnMeta.template,
            inputs: wijmo_angular2_grid_1.wjFlexGridColumnMeta.inputs,
            outputs: wijmo_angular2_grid_1.wjFlexGridColumnMeta.outputs,
            providers: [
                { provide: 'WjComponent', useExisting: core_1.forwardRef(function () { return MyColumn; }) }
            ].concat(wijmo_angular2_grid_1.wjFlexGridColumnMeta.providers)
        }), 
        __metadata('design:paramtypes', [])
    ], MyColumn);
    return MyColumn;
}(wijmo_angular2_grid_1.WjFlexGridColumn));
exports.MyColumn = MyColumn;
var MyGridModule = (function () {
    function MyGridModule() {
    }
    MyGridModule = __decorate([
        core_1.NgModule({
            imports: [wijmo_angular2_grid_1.WjGridModule, platform_browser_1.BrowserModule, forms_1.FormsModule],
            declarations: [MyGrid, MyColumn],
            exports: [MyGrid, MyColumn]
        }), 
        __metadata('design:paramtypes', [])
    ], MyGridModule);
    return MyGridModule;
}());
exports.MyGridModule = MyGridModule;
//# sourceMappingURL=MyGrid.js.map